# 挂柯南

## 服务器配置
```js
// 安装venv
python3 -m venv venv
// 启动venv
. venv/bin/activate
// 升级pip
pip install --upgrade pip
// 安装flask...
pip install Flask
pip install requests
pip install bs4
pip install gunicorn
pip install pymongo
pip install flask_cors
// 设置全局变量
export FLASK_APP=coc.py
export FLASK_ENV=development
// 启动临时服务
flask run --host=0.0.0.0 -p 8001
// beta
flask run --host=127.0.0.1 -p 5005
// 启动永久服务
gunicorn coc:app -c gunicorn.conf.py
// 查看已启动服务
pstree -ap|grep gunicorn
// 关闭某服务
kill (pid)
//关闭venv
deactivate 
```

## 错误代码一览

/api/login
100：数据校验失败
101：账户错误
102：教务挂了
200：ok

/api/laf/add
330：数据校验失败
331：插入数据库失败

/api/laf/del
340：数据校验失败
341：id不合法

/api/laf/get
350：数据校验失败
351：lost表获取失败
352：found表获取失败

/api/laf/detail
360：数据校验失败
361：数据不存在
362：id不合法

/api/laf/comment
370：数据校验失败
371：评论数据库修改失败
372：回复数据库修改失败
373：数据不存在
374：id不合法

/api/photo/upload
380：图片格式不符

/api/game/schedule/upload
400：数据校验失败
401：排名表修改失败

/api/game/schedule/get
410: 数据校验失败
411：排名表获取失败

# lost and found
* /api/laf/add
  * data
    * title
    * content
    * create_time
    * img_url
    * total_addr
    * detail_addr
    * contact_way > type + content
    * comment [ {msg, user_name, time, user_id, reply } ]
    * user_info > user_cid + user_name + user_id
    * type
* /api/laf/del
  * data
    * id
    * type
    * user_info > user_id + user_name
* /api/laf/get
* /api/laf/detail
  * data
    * id
    * type
* /api/laf/comment
  * data
    * user_info > user_id + user_name
    * msg
    * time
  * position
    * id
    * type
    * comment_type
    * comment_index
# game
* /api/game/schedule/upload
  * data
    * nick
    * count
    * time
    * sign
* /api/game/schedule/get
  * data
    * sign